- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.request_body)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.RegionList.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.RegionList.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.RegionList.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_1)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.RegionList.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_2)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.RegionList.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regions/list#try-it)

Retrieves the list of region resources available to the specified project.

To decrease latency for this method, you can optionally omit any unneeded information from the response by using a field mask. This practice is especially recommended for unused quota information (the `items.quotas` field). To exclude one or more fields, set your request's `fields` query parameter to only include the fields you need. For example, to only include the `id` and `selfLink` fields, add the query parameter `?fields=id,selfLink` to your request.

This method fails if the quota information is unavailable for the region and if the organization policy constraint `https://docs.cloud.google.com/resource-manager/docs/organization-policy/org-policy-constraints` is enforced. This constraint, when enforced, disables the fail-open behaviour when quota information (the `items.quotas` field) is unavailable for the region. It is recommended to use the default setting for the constraint unless your application requires the fail-closed behaviour for this method.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`GET https://compute.googleapis.com/compute/beta/projects/{project}/regions`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |

### Query parameters

| Parameters ||
|---|---|
| `maxResults` | `integer (https://developers.google.com/discovery/v1/type-format format)` The maximum number of results per page that should be returned. If the number of available results is larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`) |
| `pageToken` | `string` Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list request to get the next page of results. |
| `filter` | `string` A filter expression that filters resources listed in the response. Most Compute resources support two types of filter expressions: expressions that support regular expressions and expressions that follow API improvement proposal [AIP-160](https://google.aip.dev/160). These two types of filter expressions cannot be mixed in one request. If you want to use AIP-160, your expression must specify the field name, an operator, and the value that you want to use for filtering. The value must be a string, a number, or a boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or `:`. For example, if you are filtering Compute Engine instances, you can exclude instances named `example-instance` by specifying `name != example-instance`. The `:*` comparison can be used to test whether a key has been defined. For example, to find all objects with `owner` label use: labels.owner:* You can also filter nested fields. For example, you could specify `scheduling.automaticRestart = false` to include instances only if they are not scheduled for automatic restarts. You can use filtering on nested fields to filter based on [resource labels](https://docs.cloud.google.com/compute/docs/labeling-resources). To filter on multiple expressions, provide each separate expression within parentheses. For example: (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") By default, each expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For example: (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true) If you want to use a regular expression, use the `eq` (equal) or `ne` (not equal) operator against a single un-parenthesized expression with or without quotes or against multiple parenthesized expressions. Examples: `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'` `fieldname eq "double quoted literal"` `(fieldname1 eq literal) (fieldname2 ne "literal")` The literal value is interpreted as a regular expression using Google [RE2](https://github.com/google/re2/wiki/Syntax) library syntax. The literal value must match the entire field. For example, to filter for instances that do not end with name "instance", you would use `name ne .*instance`. You cannot combine constraints on multiple fields using regular expressions. |
| `orderBy` | `string` Sorts list results by a certain order. By default, results are returned in alphanumerical order based on the resource name. You can also sort results in descending order based on the creation timestamp using `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse chronological order (newest result first). Use this to sort resources like operations so that the newest operation is returned first. Currently, only sorting by `name` or `creationTimestamp desc` is supported. |
| `returnPartialSuccess` | `boolean` Opt-in for partial success behavior which provides partial results in case of failure. The default value is false. For example, when partial success behavior is enabled, aggregatedList for a single zone scope either returns all resources in the zone or no resources, with an error code. |

### Request body

The request body must be empty.

### Response body

Contains a list of region resources.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "items": [ { "kind": string, "id": string, "creationTimestamp": string, "name": string, "description": string, "status": enum, "zones": [ string ], "quotas": [ { "metric": enum, "limit": number, "usage": number, "owner": string } ], "deprecated": { "state": enum, "replacement": string, "deprecated": string, "obsolete": string, "deleted": string, "stateOverride": { "locationRolloutPolicies": { string: string, ... }, "defaultRolloutTime": string } }, "selfLink": string, "supportsPzs": boolean, "quotaStatusWarning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } } ], "nextPageToken": string, "selfLink": string, "warning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of resource. Always `compute#regionList` for lists of regions. |
| `id` | `string` Output only. Unique identifier for the resource; defined by the server. |
| `items[]` | `object` A list of Region resources. |
| `items[].kind` | `string` Output only. Type of the resource. Always `compute#region` for regions. |
| `items[].id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the resource. This identifier is defined by the server. |
| `items[].creationTimestamp` | `string` Output only. Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `items[].name` | `string` Output only. Name of the resource. |
| `items[].description` | `string` Output only. Textual description of the resource. |
| `items[].status` | `enum` Output only. Status of the region, either `UP` or `DOWN`. |
| `items[].zones[]` | `string` Output only. A list of zones available in this region, in the form of resource URLs. |
| `items[].quotas[]` | `object` Output only. Quotas assigned to this region. |
| `items[].quotas[].metric` | `enum` Output only. Name of the quota metric. |
| `items[].quotas[].limit` | `number` Output only. Quota limit for this metric. |
| `items[].quotas[].usage` | `number` Output only. Current usage of this metric. |
| `items[].quotas[].owner` | `string` Output only. Owning resource. This is the resource on which this quota is applied. |
| `items[].deprecated` | `object` Output only. The deprecation status associated with this region. |
| `items[].deprecated.state` | `enum` The deprecation state of this resource. This can be `ACTIVE`, `DEPRECATED`, `OBSOLETE`, or `DELETED`. Operations which communicate the end of life date for an image, can use `ACTIVE`. Operations which create a new resource using a `DEPRECATED` resource will return successfully, but with a warning indicating the deprecated resource and recommending its replacement. Operations which use `OBSOLETE` or `DELETED` resources will be rejected and result in an error. |
| `items[].deprecated.replacement` | `string` The URL of the suggested replacement for a deprecated resource. The suggested replacement resource must be the same kind of resource as the deprecated resource. |
| `items[].deprecated.deprecated` | `string` An optional [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) timestamp on or after which the state of this resource is intended to change to `DEPRECATED`. This is only informational and the status will not change unless the client explicitly changes it. |
| `items[].deprecated.obsolete` | `string` An optional [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) timestamp on or after which the state of this resource is intended to change to `OBSOLETE`. This is only informational and the status will not change unless the client explicitly changes it. |
| `items[].deprecated.deleted` | `string` An optional [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) timestamp on or after which the state of this resource is intended to change to `DELETED`. This is only informational and the status will not change unless the client explicitly changes it. |
| `items[].deprecated.stateOverride` | `object` The rollout policy for this deprecation. This policy is only enforced by image family views. The rollout policy restricts the zones where the associated resource is considered in a deprecated state. When the rollout policy does not include the user specified zone, or if the zone is rolled out, the associated resource is considered in a deprecated state. The rollout policy for this deprecation is read-only, except for allowlisted users. This field might not be configured. To view the latest non-deprecated image in a specific zone, use the `imageFamilyViews.get` method. |
| `items[].deprecated.stateOverride.locationRolloutPolicies` | `map (key: string, value: string)` Location based rollout policies to apply to the resource. Currently only zone names are supported and must be represented as valid URLs, like: zones/us-central1-a. The value expects an [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) timestamp on or after which the update is considered rolled out to the specified location. |
| `items[].deprecated.stateOverride.defaultRolloutTime` | `string` An optional [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) timestamp on or after which the update is considered rolled out to any zone that is not explicitly stated. |
| `items[].selfLink` | `string` Output only. Server-defined URL for the resource. |
| `items[].supportsPzs` | `boolean` Output only. Reserved for future use. |
| `items[].quotaStatusWarning` | `object` Output only. Warning of fetching the `quotas` field for this region. This field is populated only if fetching of the `quotas` field fails. |
| `items[].quotaStatusWarning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `items[].quotaStatusWarning.message` | `string` Output only. A human-readable description of the warning code. |
| `items[].quotaStatusWarning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `items[].quotaStatusWarning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `items[].quotaStatusWarning.data[].value` | `string` Output only. A warning data value corresponding to the key. |
| `nextPageToken` | `string` Output only. This token allows you to get the next page of results for list requests. If the number of results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken` in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging through the results. |
| `selfLink` | `string` Output only. Server-defined URL for this resource. |
| `warning` | `object` Output only. Informational warning message. |
| `warning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warning.message` | `string` Output only. A human-readable description of the warning code. |
| `warning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warning.data[].value` | `string` Output only. A warning data value corresponding to the key. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute.readonly`
- `
  https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.regions.list`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).